/*
  Hardware UART
*/


#include <avr/io.h>


#define BAUD 115200
#define USEU2X 1


void uart_init(void) {
  DDRD |= _BV(PD1);
#if USEU2X
  UBRR0 = (uint8_t)((double)F_CPU / (8.0 * BAUD) - 1.0 + 0.5);
  UCSR0A |= _BV(U2X0);
#else
  UBRR0 = (uint8_t)((double)F_CPU / (16.0 * BAUD) - 1.0 + 0.5);
#endif
  UCSR0B |= _BV(TXEN0);

  return;
}


void uart_putchar(unsigned char data) {
  while (bit_is_clear(UCSR0A, UDRE0)) ;
  UDR0 = data;

  return;
}
